test_gns_quickupdate.sh 2.5 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465
  1. #!/bin/sh
  2. # This file is in the public domain.
  3. trap "gnunet-arm -e -c test_gns_lookup.conf" INT
  4. LOCATION=$(which gnunet-config)
  5. if [ -z $LOCATION ]
  6. then
  7. LOCATION="gnunet-config"
  8. fi
  9. $LOCATION --version 1> /dev/null
  10. if test $? != 0
  11. then
  12. echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
  13. exit 77
  14. fi
  15. MY_EGO="myego"
  16. OTHER_EGO="delegatedego"
  17. rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
  18. which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 5"
  19. TEST_IP="127.0.0.1"
  20. gnunet-arm -s -c test_gns_lookup.conf
  21. gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
  22. gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
  23. DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
  24. gnunet-arm -i gns -c test_gns_lookup.conf
  25. gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  26. # Give GNS/namestore time to fully start and finish initial iteration
  27. sleep 2
  28. # Performing namestore update
  29. gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
  30. # Give GNS chance to observe store event via monitor
  31. sleep 1
  32. gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
  33. # give GNS chance to process monitor event
  34. sleep 1
  35. # stop everything and restart to check that DHT PUT did happen
  36. gnunet-arm -k gns -c test_gns_lookup.conf
  37. gnunet-arm -k namestore -c test_gns_lookup.conf
  38. gnunet-arm -k namecache -c test_gns_lookup.conf
  39. gnunet-arm -k zonemaster -c test_gns_lookup.conf
  40. # Purge nameacache, as we might otherwise fetch from there
  41. # FIXME: testcase started failing after the line below was fixed by adding '-f',
  42. # might have never worked (!)
  43. rm -r `gnunet-config -f -c test_gns_lookup.conf -s namecache-sqlite -o FILENAME`
  44. gnunet-arm -i namestore -c test_gns_lookup.conf
  45. gnunet-arm -i namecache -c test_gns_lookup.conf
  46. gnunet-arm -i zonemaster -c test_gns_lookup.conf
  47. gnunet-arm -i gns -c test_gns_lookup.conf
  48. RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
  49. gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
  50. gnunet-identity -D $MY_EGO -c test_gns_lookup.conf
  51. gnunet-identity -D $OTHER_EGO -c test_gns_lookup.conf
  52. gnunet-arm -e -c test_gns_lookup.conf
  53. rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
  54. if [ "$RES_IP" = "$TEST_IP" ]
  55. then
  56. exit 0
  57. else
  58. echo "Failed to properly resolve IP, expected $TEST_IP, got $RES_IP."
  59. exit 1
  60. fi